package com.dumpster.cleaner.business.ads

import android.app.Activity
import android.content.Context
import android.view.View
import android.view.ViewGroup
import androidx.annotation.LayoutRes
import com.applovin.sdk.AppLovinMediationProvider
import com.applovin.sdk.AppLovinSdk
import com.applovin.sdk.AppLovinSdkInitializationConfiguration
import com.dumpster.cleaner.BuildConfig
import com.dumpster.cleaner.GlobalConfig
import com.dumpster.cleaner.MyApplication
import com.dumpster.cleaner.bean.config.AdConfigBean.Companion.adsConfigBean
import com.dumpster.cleaner.bean.config.ConfigBean.Companion.configBean
import com.dumpster.cleaner.business.ads.admob.AdBannerMgr
import com.dumpster.cleaner.business.ads.admob.AdInterMgr
import com.dumpster.cleaner.business.ads.admob.AdNativeMgr
import com.dumpster.cleaner.business.ads.admob.AdOpenMgr
import com.dumpster.cleaner.business.ads.admob.AdmobEvent
//import com.dumpster.cleaner.business.ads.applovin.AdMaxEvent
//import com.dumpster.cleaner.business.ads.applovin.MaxInsertMgr
//import com.dumpster.cleaner.business.ads.applovin.MaxNativeMgr
//import com.dumpster.cleaner.business.ads.applovin.MaxOpenMgr
import com.dumpster.cleaner.business.helper.EventUtils
import com.dumpster.cleaner.utils.AppPreferences
import com.dumpster.cleaner.utils.LogEx
import com.dumpster.cleaner.utils.ToastUtils.toast
import com.google.android.gms.ads.MobileAds
import com.google.android.gms.ads.identifier.AdvertisingIdClient
import com.google.android.gms.ads.initialization.AdapterStatus
import java.util.Collections
import java.util.concurrent.Executors

/**
 * 广告管理类
 */
object AdsMgr {

    private val adOpenMgr by lazy {
        AdOpenMgr()
    }
    private val adInterMgr by lazy {
        AdInterMgr()
    }
    private val adNativeMgr by lazy {
        AdNativeMgr()
    }
    private val adBannerMgr by lazy {
        AdBannerMgr()
    }
//    private val maxOpenMgr by lazy {
//        MaxOpenMgr()
//    }
//    private val maxInsertMgr by lazy {
//        MaxInsertMgr()
//    }
//    private val maxNativeMgr by lazy {
//        MaxNativeMgr()
//    }

    /**
     * 是否初始化
     */
    var isAdmobInit = false
        private set

    /**
     * 是否初始化
     */
    var isMaxInit = false
        private set

    var isAdUtEvent = false

    fun eventAdUt() {
        if (!isAdUtEvent) {
            isAdUtEvent = true
            EventUtils.event("ad_ut_${configBean.ut}")
        }
    }

    /**
     * Init 初始化
     *
     * @param context 这里最好是appContext，因为是耗时操作，等它初始化完毕马上加载开屏和插屏广告
     */
    fun init(context: Context) {

//        if (configBean.isInBlackList) {
//            EventUtils.event("isInBlackList", value = "isInBlackList=${configBean.isInBlackList}")
//            return
//        }
        initAdmob(context)
//        initMax(context)

    }

    private fun initAdmob(context: Context) {
        if (isAdmobInit) return
        MobileAds.initialize(context) {
            val readyAdapter = it.adapterStatusMap.entries.find { entry ->
                entry.value.initializationState == AdapterStatus.State.READY
            }
            isAdmobInit = readyAdapter != null
            EventUtils.event("AdmobInit", "AdmobInit=$isAdmobInit")
//            context.toast("admob init")

            if (true) {
                admobInitCallBack?.invoke()
                admobInitCallBack = null
                adNativeMgr.loadAd(context, AdmobEvent("nativeAd", context::class.java.simpleName))
                adOpenMgr.loadAd(context, AdmobEvent("openAd", context::class.java.simpleName))
                adInterMgr.loadAd(context, AdmobEvent("interAd", context::class.java.simpleName))
            }
        }

    }

//    private fun initMax(context: Context) = kotlin.runCatching {
//        if (isMaxInit) return@runCatching
//        val executor = Executors.newSingleThreadExecutor()
//
//        executor.execute {
//            val currentGaid = AdvertisingIdClient.getAdvertisingIdInfo(context).id
//            AppPreferences.getInstance().getString("gid", currentGaid)
//
//            val build = AppLovinSdkInitializationConfiguration
//                .builder(GlobalConfig.KEY_MAX, context)
//
//            build.mediationProvider = AppLovinMediationProvider.MAX
//            if (BuildConfig.DEBUG) {
//                build.testDeviceAdvertisingIds = Collections.singletonList(currentGaid)
//            }
//            val initConfig = build.build()
//            runCatching {
//                AppLovinSdk.getInstance(context).initialize(initConfig) {
//                    isMaxInit = true
////                maxOpenMgr.loadAd(context)
//                    if (!adsConfigBean.adSwitch) {
////                        maxInsertMgr.loadAd(context, AdMaxEvent("interAd", context::class.java.simpleName))
//                        context.toast("max init")
//                        maxInitCallBack?.invoke()
//                        maxInitCallBack = null
//                    }
//                }
//            }
//
//        }
//
//    }

    var admobInitCallBack: (() -> Unit)? = null
    var maxInitCallBack: (() -> Unit)? = null


    /**
     * 展示开屏广告
     *
     * @param activity 当前页面
     * @param showCallBack  展示回调
     */
    fun showOpen(
        activity: Activity,
        isUnLimit: Boolean = false,
        showCallBack: AdsShowCallBack? = null,
    ) {
        eventAdUt()

        if (!adsConfigBean.isAdShow) {
            showCallBack?.failed()
            return
        }

//        if (configBean.isInBlackList) {
//            EventUtils.event("isInBlackList", "isInBlackList=${configBean.isInBlackList}")
//            showCallBack?.failed()
//            return
//        }

        val from = activity::class.java.simpleName
        if (true) {
            val admobEvent = AdmobEvent("openAd", from).apply { this.isUnLimit = isUnLimit }
            if (isAdmobInit) {
                adOpenMgr.show(activity, admobEvent, showCallBack)
            } else {
                admobInitCallBack = {
                }
                adOpenMgr.show(activity, admobEvent, showCallBack)
            }
        } else {
//            if (isMaxInit) {
//                maxOpenMgr.show(activity, isUnLimit, AdMaxEvent("openAd", from), showCallBack)
//            } else {
//                maxInitCallBack = {
//                    maxOpenMgr.show(activity, isUnLimit, AdMaxEvent("openAd", from), showCallBack)
//                }
//            }
        }

    }

    /**
     * 展示插屏广告
     *
     * @param activity 当前页面
     * @param showCallBack  展示回调
     * @param isUnLimit 是否不受限制 默认false 代表受到限制
     */
    fun showInsert(
        activity: Activity,
        isUnLimit: Boolean = false,
        showCallBack: AdsShowCallBack? = null,
    ) {
        eventAdUt()

        if (!adsConfigBean.isAdShow) {
            showCallBack?.failed()
            return
        }

//        if (configBean.isInBlackList) {
//            EventUtils.event("isInBlackList", configBean.isInBlackList.toString())
//            showCallBack?.failed()
//            return
//        }
        val from = activity::class.java.simpleName
        if (true) {
            adInterMgr.show(activity, AdmobEvent("interAd", from).apply { this.isUnLimit = isUnLimit }, showCallBack)
        } else {
//            maxInsertMgr.show(activity, isUnLimit, AdMaxEvent("interAd", from), showCallBack)
        }
    }

    /**
     * 展示原生广告
     *
     * @param nativeView 需要展示广告的布局容器
     * @param layout 原生广告布局 ,这里传入的layout要和com.example.mydemo.strategy.ads.admob.NativeView里的id一致
     */
    fun showNative(
        nativeView: NativeParentView,
        @LayoutRes layout: Int,
        nativeCallBack: ((Any?) -> Unit)? = null
    ) {
        if (!adsConfigBean.isAdShow || !LimitUtils.isShowNative(AdsType.NATIVE, null)) {
            nativeView.visibility = View.GONE
            nativeCallBack?.invoke(null)
            return
        }
        nativeView.visibility = View.VISIBLE
//        if (configBean.isInBlackList) {
//            EventUtils.event("isInBlackList", configBean.isInBlackList.toString())
//            return
//        }

        val showNative = {
            if (true) {
                adNativeMgr.show(AdmobEvent("nativeAd", "nativeAd"), nativeView, layout, nativeCallBack)
            } else {
//                maxNativeMgr.show(AdMaxEvent("nativeAd", "nativeAd"), nativeView, layout, nativeCallBack)
            }
        }

        if (isAdmobInit) {
            showNative.invoke()
        } else {
            admobInitCallBack = { showNative.invoke() }
        }

    }

    /**
     * 展示banner广告
     *
     * @param parent 展示广告的父布局容器
     */
    fun showBanner(parent: ViewGroup, collapsible: Boolean = true, adClose: (() -> Unit)? = null) {
        if (!adsConfigBean.isAdShow) {
            parent.visibility = View.GONE
            return
        }
        parent.visibility = View.VISIBLE
//        if (configBean.isInBlackList) {
//            EventUtils.event("isInBlackList", configBean.isInBlackList.toString())
//            return
//        }
        if (true) {
            adBannerMgr.show(parent, collapsible, adClose)
        }
    }

}